********************************************************************************
* EDITGEN.PRG
*
* This program generates a database (EDITGEN) which contains lines
* of code to replace the loading of 4-way array values, then outputs
* it to a file for inclusion in compiles
*
* MAINTENANCE HISTORY
*
* 08/20/86  MST  ORIGINAL PROGRAM
* 08/26/86  rvh  Converted to CONV.C calls to increase speed, decrease file size
********************************************************************************
CLEAR
@ 1, 1 SAY 'PHOENIX SYSTEMS CODE GENERATOR'
@ 2, 1 SAY '4-WAY EDITING ARRAY VALUE CODE'

@ 5, 1 SAY 'CREATING FILE BLIPGEN.PRG...'

USE BLIPEDIT
END    = CHR(10)
RESULT = 0
CALL CONV_INIT WITH 'BLIPGEN.PRG', 'W', RESULT

CALL CONV_WRITE WITH '* Copyright (c) ' + str(year(date()), 4) + ' by Phoenix Systems, Inc.' + END
CALL CONV_WRITE WITH 'PROCEDURE BLIP_GEN' + END
CALL CONV_WRITE WITH END

MID1 = "] = '"
END1 = "'" + END
MID2 = '] = '
TOTL = LASTREC()
DO CASE
CASE TOTL < 10
    L = 1
CASE TOTL < 100
    L = 2
CASE TOTL < 1000
    L = 3
CASE TOTL < 10000
    L = 4
CASE TOTL < 100000
    L = 5
ENDCASE

@ 7, 1 SAY '# OF FIELDS: ' + STR(TOTL, L)
@ 9, 1 SAY ' GENERATING: '
DO WHILE .NOT. EOF()
     NUM = STR(RECNO(), L)
    TMP1 = NUM + MID1
    TMP2 = NUM + MID2
    @ 9, 14 SAY NUM
    LINE =	      '  VAR [' + TMP1 + TRIM(VAR)     + END1
    LINE = LINE + '  ROW [' + TMP2 + STR(ROW, L)   + END
    LINE = LINE + '  COL [' + TMP2 + STR(COL, L)   + END
    LINE = LINE + '  PIC [' + TMP1 + TRIM(PIC)     + END1
    LINE = LINE + '   UP [' + TMP2 + STR(UP, L)    + END
    LINE = LINE + ' DOWN [' + TMP2 + STR(DOWN, L)  + END
    LINE = LINE + ' LEFT [' + TMP2 + STR(LEFT, L)  + END
    LINE = LINE + 'RIGHT [' + TMP2 + STR(RIGHT, L) + END
    CALL CONV_WRITE WITH LINE
    SKIP
ENDDO
CALL CONV_WRITE WITH CHR(26)  && EOF
CALL CONV_END
RETURN
